# coding: utf-8

"""
    BoldSign API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1
    Contact: support@boldsign.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from boldsign.models.id_verification import IdVerification
from boldsign.models.phone_number_webhook_model import PhoneNumberWebhookModel
from boldsign.models.signer_authentication_settings import SignerAuthenticationSettings
from typing import Optional, Set, Tuple
from typing_extensions import Self
import io
from pydantic import StrictBool
from typing import Union

class DocumentSignerWebhookModel(BaseModel):
    """
    DocumentSignerWebhookModel
    """ # noqa: E501
    signer_name: Optional[StrictStr] = Field(default=None, alias="signerName")
    signer_role: Optional[StrictStr] = Field(default=None, alias="signerRole")
    signer_email: Optional[StrictStr] = Field(default=None, alias="signerEmail")
    phone_number: Optional[PhoneNumberWebhookModel] = Field(default=None, alias="phoneNumber")
    status: Optional[StrictStr] = None
    enable_access_code: Optional[StrictBool] = Field(default=None, alias="enableAccessCode")
    is_authentication_failed: Optional[StrictBool] = Field(default=None, alias="isAuthenticationFailed")
    enable_email_otp: Optional[StrictBool] = Field(default=None, alias="enableEmailOTP")
    is_delivery_failed: Optional[StrictBool] = Field(default=None, alias="isDeliveryFailed")
    is_viewed: Optional[StrictBool] = Field(default=None, alias="isViewed")
    order: Optional[StrictInt] = None
    signer_type: Optional[StrictStr] = Field(default=None, alias="signerType")
    is_reassigned: Optional[StrictBool] = Field(default=None, alias="isReassigned")
    reassign_message: Optional[StrictStr] = Field(default=None, alias="reassignMessage")
    decline_message: Optional[StrictStr] = Field(default=None, alias="declineMessage")
    last_activity_date: Optional[datetime] = Field(default=None, alias="lastActivityDate")
    authentication_type: Optional[StrictStr] = Field(default=None, alias="authenticationType")
    id_verification: Optional[IdVerification] = Field(default=None, alias="idVerification")
    allow_field_configuration: Optional[StrictBool] = Field(default=None, alias="allowFieldConfiguration")
    last_reminder_sent_on: Optional[datetime] = Field(default=None, alias="lastReminderSentOn")
    authentication_retry_count: Optional[StrictInt] = Field(default=None, alias="authenticationRetryCount")
    authentication_settings: Optional[SignerAuthenticationSettings] = Field(default=None, alias="authenticationSettings")
    __properties: ClassVar[List[str]] = ["signerName", "signerRole", "signerEmail", "phoneNumber", "status", "enableAccessCode", "isAuthenticationFailed", "enableEmailOTP", "isDeliveryFailed", "isViewed", "order", "signerType", "isReassigned", "reassignMessage", "declineMessage", "lastActivityDate", "authenticationType", "idVerification", "allowFieldConfiguration", "lastReminderSentOn", "authenticationRetryCount", "authenticationSettings"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['None', 'NotCompleted', 'Completed', 'Declined', 'Revoked', 'Expired']):
            raise ValueError("must be one of enum values ('None', 'NotCompleted', 'Completed', 'Declined', 'Revoked', 'Expired')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        arbitrary_types_allowed=True,
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    def to_json_form_params(self, excluded_fields: Set[str] = None) -> List[Tuple[str, str]]:
        data: List[Tuple[str, str]] = []

        for key, value in self.to_dict(excluded_fields).items():
            if isinstance(value, (int, str, bool)):
                data.append((key, value))
            elif isinstance(value, list):
                for index, item in enumerate(value):
                    if(isinstance(item, (int, str, bool))):
                        data.append((f'{key}[{index}]', item))
                    else:
                        data.append((key, json.dumps(value[index], ensure_ascii=False)))
            else:
                data.append((key, json.dumps(value, ensure_ascii=False)))

        return data

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DocumentSignerWebhookModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self, excluded_fields: Set[str] = None) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DocumentSignerWebhookModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "signerName": obj.get("signerName"),
            "signerRole": obj.get("signerRole"),
            "signerEmail": obj.get("signerEmail"),
            "phoneNumber": PhoneNumberWebhookModel.from_dict(obj["phoneNumber"]) if obj.get("phoneNumber") is not None else None,
            "status": obj.get("status"),
            "enableAccessCode": obj.get("enableAccessCode"),
            "isAuthenticationFailed": obj.get("isAuthenticationFailed"),
            "enableEmailOTP": obj.get("enableEmailOTP"),
            "isDeliveryFailed": obj.get("isDeliveryFailed"),
            "isViewed": obj.get("isViewed"),
            "order": obj.get("order"),
            "signerType": obj.get("signerType"),
            "isReassigned": obj.get("isReassigned"),
            "reassignMessage": obj.get("reassignMessage"),
            "declineMessage": obj.get("declineMessage"),
            "lastActivityDate": obj.get("lastActivityDate"),
            "authenticationType": obj.get("authenticationType"),
            "idVerification": IdVerification.from_dict(obj["idVerification"]) if obj.get("idVerification") is not None else None,
            "allowFieldConfiguration": obj.get("allowFieldConfiguration"),
            "lastReminderSentOn": obj.get("lastReminderSentOn"),
            "authenticationRetryCount": obj.get("authenticationRetryCount"),
            "authenticationSettings": SignerAuthenticationSettings.from_dict(obj["authenticationSettings"]) if obj.get("authenticationSettings") is not None else None
        })
        return _obj

    @classmethod
    def init(cls, data: Any) -> Self:
        """
        Attempt to instantiate and hydrate a new instance of this class
        """
        if isinstance(data, str):
            data = json.loads(data)

        return cls.from_dict(data)

    @classmethod
    def openapi_types(cls) -> Dict[str, str]:
        return {
            "signer_name": "(str,)",
            "signer_role": "(str,)",
            "signer_email": "(str,)",
            "phone_number": "(PhoneNumberWebhookModel,)",
            "status": "(str,)",
            "enable_access_code": "(bool,)",
            "is_authentication_failed": "(bool,)",
            "enable_email_otp": "(bool,)",
            "is_delivery_failed": "(bool,)",
            "is_viewed": "(bool,)",
            "order": "(int,)",
            "signer_type": "(str,)",
            "is_reassigned": "(bool,)",
            "reassign_message": "(str,)",
            "decline_message": "(str,)",
            "last_activity_date": "(datetime,)",
            "authentication_type": "(str,)",
            "id_verification": "(IdVerification,)",
            "allow_field_configuration": "(bool,)",
            "last_reminder_sent_on": "(datetime,)",
            "authentication_retry_count": "(int,)",
            "authentication_settings": "(SignerAuthenticationSettings,)",
        }

    @classmethod
    def openapi_type_is_array(cls, property_name: str) -> bool:
        return property_name in [
        ]

