# coding: utf-8

"""
    BoldSign API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1
    Contact: support@boldsign.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from boldsign.models.template_cc_webhook_model import TemplateCcWebhookModel
from boldsign.models.template_sender import TemplateSender
from boldsign.models.template_signer import TemplateSigner
from typing import Optional, Set, Tuple
from typing_extensions import Self
import io
from pydantic import StrictBool
from typing import Union

class TemplateEvent(BaseModel):
    """
    TemplateEvent
    """ # noqa: E501
    object: Optional[StrictStr] = None
    template_id: Optional[StrictStr] = Field(default=None, alias="templateId")
    allow_new_files: Optional[StrictBool] = Field(default=None, alias="allowNewFiles")
    allow_modify_files: Optional[StrictBool] = Field(default=None, alias="allowModifyFiles")
    sender_detail: Optional[TemplateSender] = Field(default=None, alias="senderDetail")
    cc_details: Optional[List[TemplateCcWebhookModel]] = Field(default=None, alias="ccDetails")
    created_date: Optional[datetime] = Field(default=None, alias="createdDate")
    activity_date: Optional[datetime] = Field(default=None, alias="activityDate")
    activity_by: Optional[StrictStr] = Field(default=None, alias="activityBy")
    message_title: Optional[StrictStr] = Field(default=None, alias="messageTitle")
    status: Optional[StrictStr] = None
    signer_details: Optional[List[TemplateSigner]] = Field(default=None, alias="signerDetails")
    enable_signing_order: Optional[StrictBool] = Field(default=None, alias="enableSigningOrder")
    template_name: Optional[StrictStr] = Field(default=None, alias="templateName")
    template_description: Optional[StrictStr] = Field(default=None, alias="templateDescription")
    error_message: Optional[StrictStr] = Field(default=None, alias="errorMessage")
    is_template: Optional[StrictBool] = Field(default=False, alias="isTemplate")
    brand_id: Optional[StrictStr] = Field(default=None, alias="brandId")
    on_behalf_of: Optional[StrictStr] = Field(default=None, alias="onBehalfOf")
    labels: Optional[List[StrictStr]] = None
    template_labels: Optional[List[StrictStr]] = Field(default=None, alias="templateLabels")
    __properties: ClassVar[List[str]] = ["object", "templateId", "allowNewFiles", "allowModifyFiles", "senderDetail", "ccDetails", "createdDate", "activityDate", "activityBy", "messageTitle", "status", "signerDetails", "enableSigningOrder", "templateName", "templateDescription", "errorMessage", "isTemplate", "brandId", "onBehalfOf", "labels", "templateLabels"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['InProgress', 'Completed', 'Declined', 'Expired', 'Revoked', 'Draft', 'Scheduled']):
            raise ValueError("must be one of enum values ('InProgress', 'Completed', 'Declined', 'Expired', 'Revoked', 'Draft', 'Scheduled')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        arbitrary_types_allowed=True,
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    def to_json_form_params(self, excluded_fields: Set[str] = None) -> List[Tuple[str, str]]:
        data: List[Tuple[str, str]] = []

        for key, value in self.to_dict(excluded_fields).items():
            if isinstance(value, (int, str, bool)):
                data.append((key, value))
            elif isinstance(value, list):
                for index, item in enumerate(value):
                    if(isinstance(item, (int, str, bool))):
                        data.append((f'{key}[{index}]', item))
                    else:
                        data.append((key, json.dumps(value[index], ensure_ascii=False)))
            else:
                data.append((key, json.dumps(value, ensure_ascii=False)))

        return data

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TemplateEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self, excluded_fields: Set[str] = None) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TemplateEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object"),
            "templateId": obj.get("templateId"),
            "allowNewFiles": obj.get("allowNewFiles"),
            "allowModifyFiles": obj.get("allowModifyFiles"),
            "senderDetail": TemplateSender.from_dict(obj["senderDetail"]) if obj.get("senderDetail") is not None else None,
            "ccDetails": [TemplateCcWebhookModel.from_dict(_item) for _item in obj["ccDetails"]] if obj.get("ccDetails") is not None else None,
            "createdDate": obj.get("createdDate"),
            "activityDate": obj.get("activityDate"),
            "activityBy": obj.get("activityBy"),
            "messageTitle": obj.get("messageTitle"),
            "status": obj.get("status"),
            "signerDetails": [TemplateSigner.from_dict(_item) for _item in obj["signerDetails"]] if obj.get("signerDetails") is not None else None,
            "enableSigningOrder": obj.get("enableSigningOrder"),
            "templateName": obj.get("templateName"),
            "templateDescription": obj.get("templateDescription"),
            "errorMessage": obj.get("errorMessage"),
            "isTemplate": obj.get("isTemplate") if obj.get("isTemplate") is not None else False,
            "brandId": obj.get("brandId"),
            "onBehalfOf": obj.get("onBehalfOf"),
            "labels": obj.get("labels"),
            "templateLabels": obj.get("templateLabels")
        })
        return _obj

    @classmethod
    def init(cls, data: Any) -> Self:
        """
        Attempt to instantiate and hydrate a new instance of this class
        """
        if isinstance(data, str):
            data = json.loads(data)

        return cls.from_dict(data)

    @classmethod
    def openapi_types(cls) -> Dict[str, str]:
        return {
            "object": "(str,)",
            "template_id": "(str,)",
            "allow_new_files": "(bool,)",
            "allow_modify_files": "(bool,)",
            "sender_detail": "(TemplateSender,)",
            "cc_details": "(List[TemplateCcWebhookModel],)",
            "created_date": "(datetime,)",
            "activity_date": "(datetime,)",
            "activity_by": "(str,)",
            "message_title": "(str,)",
            "status": "(str,)",
            "signer_details": "(List[TemplateSigner],)",
            "enable_signing_order": "(bool,)",
            "template_name": "(str,)",
            "template_description": "(str,)",
            "error_message": "(str,)",
            "is_template": "(bool,)",
            "brand_id": "(str,)",
            "on_behalf_of": "(str,)",
            "labels": "(List[str],)",
            "template_labels": "(List[str],)",
        }

    @classmethod
    def openapi_type_is_array(cls, property_name: str) -> bool:
        return property_name in [
            "cc_details",
            "signer_details",
            "labels",
            "template_labels",
        ]

