# coding: utf-8

"""
    BoldSign API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1
    Contact: support@boldsign.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from boldsign.models.document_event import DocumentEvent
from boldsign.models.identity_verification_event import IdentityVerificationEvent
from boldsign.models.sender_identity_event import SenderIdentityEvent
from boldsign.models.template_event import TemplateEvent
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

WEBHOOKEVENTDATA_ONE_OF_SCHEMAS = ["DocumentEvent", "IdentityVerificationEvent", "SenderIdentityEvent", "TemplateEvent"]

class WebhookEventData(BaseModel):
    """
    WebhookEventData
    """
    # data type: DocumentEvent
    oneof_schema_1_validator: Optional[DocumentEvent] = None
    # data type: TemplateEvent
    oneof_schema_2_validator: Optional[TemplateEvent] = None
    # data type: SenderIdentityEvent
    oneof_schema_3_validator: Optional[SenderIdentityEvent] = None
    # data type: IdentityVerificationEvent
    oneof_schema_4_validator: Optional[IdentityVerificationEvent] = None
    actual_instance: Optional[Union[DocumentEvent, IdentityVerificationEvent, SenderIdentityEvent, TemplateEvent]] = None
    one_of_schemas: Set[str] = { "DocumentEvent", "IdentityVerificationEvent", "SenderIdentityEvent", "TemplateEvent" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = WebhookEventData.model_construct()
        error_messages = []
        match = 0
        # validate data type: DocumentEvent
        if not isinstance(v, DocumentEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DocumentEvent`")
        else:
            match += 1
        # validate data type: TemplateEvent
        if not isinstance(v, TemplateEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TemplateEvent`")
        else:
            match += 1
        # validate data type: SenderIdentityEvent
        if not isinstance(v, SenderIdentityEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SenderIdentityEvent`")
        else:
            match += 1
        # validate data type: IdentityVerificationEvent
        if not isinstance(v, IdentityVerificationEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `IdentityVerificationEvent`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in WebhookEventData with oneOf schemas: DocumentEvent, IdentityVerificationEvent, SenderIdentityEvent, TemplateEvent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in WebhookEventData with oneOf schemas: DocumentEvent, IdentityVerificationEvent, SenderIdentityEvent, TemplateEvent. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("object")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `object` in the input.")

        # check if data type is `DocumentEvent`
        if _data_type == "document":
            instance.actual_instance = DocumentEvent.from_json(json_str)
            return instance

        # check if data type is `IdentityVerificationEvent`
        if _data_type == "identityVerification":
            instance.actual_instance = IdentityVerificationEvent.from_json(json_str)
            return instance

        # check if data type is `SenderIdentityEvent`
        if _data_type == "senderIdentity":
            instance.actual_instance = SenderIdentityEvent.from_json(json_str)
            return instance

        # check if data type is `TemplateEvent`
        if _data_type == "template":
            instance.actual_instance = TemplateEvent.from_json(json_str)
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], DocumentEvent, IdentityVerificationEvent, SenderIdentityEvent, TemplateEvent]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


